the PackageManagerTest::getPackageReturnsTheSpecifiedPackage is failing on hhvm, because it HHVM doesn't support calling
key() on objects.
So it is failing now with "Fatal error: Cannot access empty property in..." 
Responsible code is in Package->getNamespace()

$namespaces = $manifest->autoload->{'psr-0'};
if (count($namespaces) === 1) {
    $namespace = key($namespaces);
}

it can be solved by first cast object to an array

$namespaces = (array)$manifest->autoload->{'psr-0'};
if (count($namespaces) === 1) {
    $namespace = key($namespaces);
}

quote from
https://github.com/facebook/hhvm/blob/master/hphp/doc/inconsistencies#L90-95
about this inconsistency:

(5) Object internal cursors

Under Zend PHP, objects have an internal cursor (similar to the array internal
cursor) that can be used to iterate over the object's properties. Under HipHop
VM, objects do not have internal cursors, and the next(), prev(), current(),
key(), reset(), end(), and each() builtin functions do not support objects.

Related issues:
related to TYPO3 Flow Base Distribution - Task # 57992: Make package HHVM com... Resolved 2014-04-16

Associated revisions
Revision 06290480 - 2014-05-02 21:51 - Tymoteusz Motylewski

[TASK] Make Flow Package HHVM compatible

2015-08-04 1/2

https://github.com/facebook/hhvm/blob/master/hphp/doc/inconsistencies#L90-95


HHVM doesn't support calling array functions like key()
on objects, we need to cast object to array first.
History
#1 - 2014-04-16 16:57 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/29508

#2 - 2014-04-16 17:03 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/29508

#3 - 2014-05-02 22:30 - Tymoteusz Motylewski
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:06290480dc7dca7152d859a4cebc45131880011b.
